from ..interfaces import FightingEntity


class Player(FightingEntity):
    maxhealth: int = 20
    strength: int = 5
    intelligence: int = 1
    charisma: int = 1
    dexterity: int = 1
    constitution: int = 1
    level: int = 1
    current_xp: int = 0
    max_xp: int = 10

    def move_up(self) -> bool:
        return self.check_move(self.y - 1, self.x, True)

    def move_down(self) -> bool:
        return self.check_move(self.y + 1, self.x, True)

    def move_left(self) -> bool:
        return self.check_move(self.y, self.x - 1, True)

    def move_right(self) -> bool:
        return self.check_move(self.y, self.x + 1, True)

    def level_up(self) -> None:
        while self.current_xp > self.max_xp:
            self.level += 1
            self.current_xp -= self.max_xp
            self.max_xp = self.level * 10

    def add_xp(self, xp: int) -> None:
        self.current_xp += xp
        self.level_up()
